//Create a class for step sensor
package StepSensor
import SmartThing.SmartThings

//Importing mutable integer class
import MutableInteger.MutableInteger

public class StepSensors extends SmartThings {
	List stepSensors = new ArrayList()
		
	StepSensors(Closure sendEvent, boolean init) {
		// Only initialize one time since we only have one device for each capability
		stepSensors = smartThings

		// Initialization
		StringBuilder id = new StringBuilder("stepSensorID0")
		StringBuilder label = new StringBuilder("stepSensor")
		StringBuilder displayName = new StringBuilder("stepSensor0")
		MutableInteger steps = new MutableInteger()
		MutableInteger goal = new MutableInteger()

		if (init) {
			goal.setValue(50)
			steps.setValue(35)
		} else {
			goal.setValue(40)
			steps.setValue(60)
		}

		stepSensors.add(new StepSensor(sendEvent, id, label, displayName, steps, goal))
	}

	// Methods to return values
	def getCurrentSteps() {
		List tmpValues = new ArrayList()
		tmpValues.add(stepSensors[0].getCurrentSteps())
		return tmpValues
	}

	def getCurrentGoal() {
		List tmpValues = new ArrayList()
		tmpValues.add(stepSensors[0].getCurrentGoal())
		return tmpValues
	}
}
